//  
//  Author:
//       smdn <smdn@smdn.jp>
// 
//  Copyright (c) 2003-2013 smdn
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

using System;
using System.Collections.Generic;
using System.Text;

namespace Smdn.Applications.BittenBaum.Graphing {
  public class Grapher {
    private readonly GraphingContext context = null;

    public Grapher(GraphingContext context)
    {
      if (context == null)
        throw new ArgumentNullException("context");

      this.context = context;
    }

    public void Create()
    {
      context.Status.StatusText = "グラフを作成中";

      switch (context.Parameter.Type) {
        case GraphType.Disc:
          context.Result.Graph = Disc.Disc.Create(context);
          break;

        default:
          throw new NotImplementedException(string.Format("{0}のグラフは作れません", context.Parameter.Type));
      }

      context.Status.StatusText = "グラフを作成が完了しました";
    }
}
}
