//  
//  Author:
//       smdn <smdn@smdn.jp>
// 
//  Copyright (c) 2003-2013 smdn
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

using System;
using System.Collections.Generic;
using System.Drawing;

namespace Smdn.Applications.BittenBaum.Rendering {
  using Graphing;

  public class PartialGraphImage : IDisposable {
    public IEnumerable<IGraphElement> Elements {
      get; private set;
    }

    public Bitmap Image {
      get; private set;
    }

    public int ImageOffsetX = 0;
    public int ImageOffsetY = 0;

    public PartialGraphImage(IEnumerable<IGraphElement> elements, Bitmap partialImage)
    {
      if (null == elements)
        throw new ArgumentNullException("elements");

      this.Elements = elements;
      this.Image = partialImage;
    }

    public void Dispose()
    {
      if (Image != null) {
        Image.Dispose();
        Image = null;
      }
    }

    void IDisposable.Dispose()
    {
      this.Dispose();
    }
  }
}
