//  
//  Author:
//       smdn <smdn@smdn.jp>
// 
//  Copyright (c) 2003-2013 smdn
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

using System;

namespace Smdn.Applications.BittenBaum {
  /// <summary>
  /// タスク実行コンテキストの基底クラス
  /// </summary>
  public abstract class TaskContext {
    /// <summary>
    /// タスクに引き渡すパラメータの基底クラス
    /// </summary>
    public abstract class TaskParameter {
    }

    /// <summary>
    /// タスクの状態の基底クラス
    /// </summary>
    public abstract class TaskStatus {
      public abstract int Total { get;}
      public abstract int Processed { get;}

      public virtual float Percentage {
        get { return Processed / (float)Total; }
      }

      public string StatusText = string.Empty;
    }

    /// <summary>
    /// タスクの結果の基底クラス
    /// </summary>
    public abstract class TaskResult {
    }
  }
}